## parmetis 3.1

=== Makefile ===


default:
	(cd METISLib ; make ) 
	(cd ParMETISLib ; make ) 
	(cd Programs ; make ) 

clean:
	(cd METISLib ; make realclean )
	(cd ParMETISLib ; make realclean )
	(cd Programs ; make realclean )

=== ParMETISLib/Makefile ===
include ../Makefile.in


CFLAGS = $(COPTIONS) $(OPTFLAGS) -I. $(INCDIR)


OBJS = comm.o util.o debug.o setup.o grsetup.o timer.o \
       node_refine.o initmsection.o order.o \
       xyzpart.o pspases.o frename.o \
       iintsort.o iidxsort.o ikeysort.o ikeyvalsort.o \
       kmetis.o gkmetis.o ometis.o \
       initpart.o match.o coarsen.o \
       kwayfm.o kwayrefine.o kwaybalance.o \
       remap.o stat.o fpqueue.o \
       ametis.o rmetis.o lmatch.o initbalance.o \
       mdiffusion.o diffutil.o wave.o \
       csrmatch.o redomylink.o balancemylink.o \
       selectq.o akwayfm.o serial.o move.o \
       mmetis.o mesh.o memory.o weird.o backcompat.o

.c.o:
	$(CC) $(CFLAGS) -c $*.c


../libparmetis.a: $(OBJS)
	$(AR) $@ $(OBJS)
	$(RANLIB) $@

clean:
	rm -f *.o 

realclean:
	rm -f *.o ; rm -f ../libparmetis.a


checkin:
	@for file in *.[c,h]; \
	do \
	ci -u -m'Maintance' $$file;\
	done 

checkin2:
	@for file in *.[c,h]; \
	do \
	ci $$file;\
	rcs -U $$file;\
	co $$file;\
	done

=== Programs/Makefile ===
include ../Makefile.in

BINDIR = ../Graphs

INCLUDES = -I./ -I../ParMETISLib $(INCDIR) 
CFLAGS = $(COPTIONS) $(OPTFLAGS) $(INCLUDES)


LIBSDIR = -L.. $(LIBDIR) 
LIBS = -lparmetis -lmetis $(XTRALIBS) -lm
PARMETISLIB = ../libparmetis.a ../libmetis.a


PTESTOBJS = ptest.o io.o adaptgraph.o 
MESHTESTOBJS = mtest.o io.o
PARMETISOBJS = parmetis.o io.o adaptgraph.o

          
.c.o:
	$(CC) $(CFLAGS) -c $*.c


default: $(BINDIR)/ptest$(VERNUM) $(BINDIR)/mtest$(VERNUM) 

$(BINDIR)/mtest$(VERNUM): $(MESHTESTOBJS) $(PARMETISLIB)
	$(LD)  -o $@ $(MESHTESTOBJS) $(LIBSDIR) $(LIBS)
	chmod 744 $@

$(BINDIR)/ptest$(VERNUM): $(PTESTOBJS) $(PARMETISLIB)
	$(LD)  -o $@ $(PTESTOBJS) $(LIBSDIR) $(LIBS)
	chmod 744 $@

clean:
	rm -f *.o ;\
	rm -f $(BINDIR)/ptest$(VERNUM) 
	rm -f $(BINDIR)/mtest$(VERNUM) 

realclean:
	rm -f *.o ;\
	rm -f $(BINDIR)/ptest$(VERNUM) 
	rm -f $(BINDIR)/mtest$(VERNUM) 


checkin:
	@for file in *.[c,h]; \
	do \
	ci -u -m'Maintance' $$file;\
	done 

checkin2:
	@for file in *.[c,h]; \
	do \
	ci $$file;\
	rcs -U $$file;\
	co $$file;\
	done

## parmetis 3.1.1

=== Makefile ===
--- 
+++ 
@@ -6,8 +6,22 @@
 	(cd Programs ; make ) 
 
 clean:
+	(cd METISLib ; make clean )
+	(cd ParMETISLib ; make clean )
+	(cd Programs ; make clean )
+
+realclean:
 	(cd METISLib ; make realclean )
 	(cd ParMETISLib ; make realclean )
 	(cd Programs ; make realclean )
 
 
+checkin:
+	(cd METISLib ; make checkin )
+	(cd ParMETISLib ; make checkin )
+	(cd Programs ; make checkin )
+
+checkin2:
+	(cd METISLib ; make checkin2 )
+	(cd ParMETISLib ; make checkin2 )
+	(cd Programs ; make checkin2 )

=== METISLib/Makefile ===
include ../Makefile.in


CFLAGS = $(COPTIONS) $(OPTFLAGS) -I. $(INCDIR)


OBJS = coarsen.o fm.o initpart.o match.o ccgraph.o \
       pmetis.o pqueue.o refine.o util.o timing.o debug.o \
       bucketsort.o graph.o stat.o kmetis.o kwayrefine.o \
       kwayfm.o balance.o ometis.o srefine.o sfm.o separator.o \
       mincover.o mmd.o mesh.o meshpart.o frename.o fortran.o \
       myqsort.o compress.o parmetis.o estmem.o \
       mpmetis.o mcoarsen.o mmatch.o minitpart.o mbalance.o \
       mutil.o mkmetis.o mkwayrefine.o mkwayfmh.o \
       mrefine2.o minitpart2.o mbalance2.o mfm2.o \
       kvmetis.o kwayvolrefine.o kwayvolfm.o subdomains.o \
       mfm.o memory.o mrefine.o checkgraph.o

.c.o:
	$(CC) $(CFLAGS) -c $*.c

../libmetis.a: $(OBJS)
	$(AR) $@ $(OBJS)
	$(RANLIB) $@

clean:
	rm -f *.o 

realclean:
	rm -f *.o ; rm -f ../libmetis.a


checkin:
	@for file in *.[c,h]; \
	do \
	ci -u -m'Maintance' $$file;\
	done 

checkin2:
	@for file in *.[c,h]; \
	do \
	ci $$file;\
	rcs -U $$file;\
	co $$file;\
	done

=== ParMETISLib/Makefile ===
--- 
+++ 
@@ -9,14 +9,14 @@
        xyzpart.o pspases.o frename.o \
        iintsort.o iidxsort.o ikeysort.o ikeyvalsort.o \
        kmetis.o gkmetis.o ometis.o \
-       initpart.o match.o coarsen.o \
+       initpart.o match.o \
        kwayfm.o kwayrefine.o kwaybalance.o \
        remap.o stat.o fpqueue.o \
        ametis.o rmetis.o lmatch.o initbalance.o \
        mdiffusion.o diffutil.o wave.o \
        csrmatch.o redomylink.o balancemylink.o \
        selectq.o akwayfm.o serial.o move.o \
-       mmetis.o mesh.o memory.o weird.o backcompat.o
+       mmetis.o mesh.o memory.o weird.o backcompat.o 
 
 .c.o:
 	$(CC) $(CFLAGS) -c $*.c

=== Programs/Makefile ===
include ../Makefile.in

BINDIR = ../Graphs

INCLUDES = -I./ -I../ParMETISLib $(INCDIR) 
CFLAGS = $(COPTIONS) $(OPTFLAGS) $(INCLUDES)


LIBSDIR = -L.. $(LIBDIR) 
LIBS = -lparmetis -lmetis $(XTRALIBS) -lm
PARMETISLIB = ../libparmetis.a ../libmetis.a


PTESTOBJS = ptest.o io.o adaptgraph.o 
MESHTESTOBJS = mtest.o io.o
PARMETISOBJS = parmetis.o io.o adaptgraph.o
POMETISOBJS = pometis.o io.o 

          
.c.o:
	$(CC) $(CFLAGS) -c $*.c


default: $(BINDIR)/ptest$(VERNUM) $(BINDIR)/mtest$(VERNUM) $(BINDIR)/parmetis$(VERNUM) \
         $(BINDIR)/pometis$(VERNUM)

$(BINDIR)/mtest$(VERNUM): $(MESHTESTOBJS) $(PARMETISLIB)
	$(LD)  -o $@ $(MESHTESTOBJS) $(LIBSDIR) $(LIBS)
	chmod 744 $@

$(BINDIR)/ptest$(VERNUM): $(PTESTOBJS) $(PARMETISLIB)
	$(LD)  -o $@ $(PTESTOBJS) $(LIBSDIR) $(LIBS)
	chmod 744 $@

$(BINDIR)/parmetis$(VERNUM): $(PARMETISOBJS) $(PARMETISLIB)
	$(LD)  -o $@ $(PARMETISOBJS) $(LIBSDIR) $(LIBS)
	chmod 744 $@

$(BINDIR)/pometis$(VERNUM): $(POMETISOBJS) $(PARMETISLIB)
	$(LD)  -o $@ $(POMETISOBJS) $(LIBSDIR) $(LIBS)
	chmod 744 $@


clean:
	rm -f *.o ;\
	rm -f $(BINDIR)/ptest$(VERNUM) 
	rm -f $(BINDIR)/mtest$(VERNUM) 
	rm -f $(BINDIR)/parmetis$(VERNUM) 
	rm -f $(BINDIR)/pometis$(VERNUM) 

realclean:
	rm -f *.o ;\
	rm -f $(BINDIR)/ptest$(VERNUM) 
	rm -f $(BINDIR)/mtest$(VERNUM) 
	rm -f $(BINDIR)/parmetis$(VERNUM) 
	rm -f $(BINDIR)/pometis$(VERNUM)

=== debian/changelog ===
parmetis (3.1.1-4build1) trusty; urgency=medium

  * No-change rebuild for libopenmpi1.3 -> libopenmpi1.6 transition.

 -- Logan Rosen <logan@ubuntu.com>  Mon, 16 Dec 2013 00:21:14 -0500

parmetis (3.1.1-4) unstable; urgency=low

  * Team upload
  * Package migrated to the Debian Science team
  * Standards-Version updated to version 3.9.2
  * Show compilation warnings at build time
  * Programs/Makefile: Explicitly link against mpi to resolve FTBFS.
    Thanks to Daniel T Chen for providing the patch (Closes: #639743)
    (LP: #832950)
  * Switch to dpkg-source 3.0 (quilt) format

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 30 Aug 2011 00:35:57 +0200

parmetis (3.1.1-3) unstable; urgency=high

  * Team upload
  * XS-Autobuild added with high priority to make it to Squeeze.
    Following Adam D. Barratt advices.

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 27 Jan 2011 23:36:35 +0100

parmetis (3.1.1-2) unstable; urgency=low

  * Team upload
  * Fix a FTBFS. Thanks to Jakub Wilk for the patch (Closes: #610956)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 27 Jan 2011 09:11:56 +0100

parmetis (3.1.1-1) unstable; urgency=low

  [ Daniel Leidert (dale) ]
  * METISLib/Makefile: Link with -lm for missing symbols.
  * ParMETISLib/Makefile: Ditto. Further link with -lmetis.
  * debian/control: Added Homepage field.
    (Vcs-Svn): Fixed.
    (Depends): Fixed deprecated substvar to be binNMU safe.
  * debian/copyright: Added missing copyright information to make lintian
    happy.
  * debian/parmetis-doc.doc-base (Section): Fixed.
  * debian/watch: Added.

  [Christophe Prud'homme]
  * New upstream release
  * debian/control: update Standards-Version to 3.8.2
  * debian/control: added ${misc:Depends}
  * deboan/control: use mpi-defaults
  * debian/rules: use /usr/include/mpi in CPPFLAGS now

 -- Christophe Prud'homme <prudhomm@debian.org>  Wed, 29 Jul 2009 07:11:06 +0200

parmetis (3.1-10) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/control,rules: support for all arch

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 04 Jan 2008 13:37:39 +0100

parmetis (3.1-9) unstable; urgency=low

  [Christophe Prud'homme]
  * Bug fix: "parmetis_3.1-8+b1(unstable/amd64/xenophanes): FTBFS:
    Doesn&#39;t search for mpi.h in right include path", thanks to Marc
    &#39;HE&#39; Brockschmidt (Closes: #459025).
  * Bug fix: "parmetis: rebuild with OpenMPI", thanks to Adam C Powell IV
    (Closes: #447671).
  * Bug fix: "parmetis_3.1-8(hppa/experimental): FTBFS: new build-dep
    removes arch support", thanks to Frank Lichtenheld (Closes: #449018).
  * Update Standards-Version to 3.7.3 (no change)

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 04 Jan 2008 12:13:27 +0100

parmetis (3.1-8) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/control: Build-Depends on openmpi, Depends on mpich or openmpi
  * Bug fix: "Wishlist: lam version.", thanks to Viral Shah (Closes:
    #200409).
  * debian/control: XS-Vcs* control fields replaced by their Vcs*
    counterparts

 -- Christophe Prud'homme <prudhomm@debian.org>  Thu, 01 Nov 2007 10:01:57 +0100

parmetis (3.1-7) unstable; urgency=low

  [Christophe Prud'homme]
  * really fix FTBFS

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 15 Jul 2007 11:16:13 +0200

parmetis (3.1-6) unstable; urgency=low

  * Bug fix: "parmetis_3.1-5(hppa/experimental): FTBFS: error:
    metis/stdheaders.h: No such file or directory", thanks to Frank
    Lichtenheld (Closes: #432605).

 -- Christophe Prud'homme <prudhomm@debian.org>  Wed, 11 Jul 2007 04:57:37 +0200

parmetis (3.1-5) unstable; urgency=low

  [ Rafael Laboissiere ]
  * debian/control: Added XS-Vcs-Svn and XS-Vcs-Browser fields to the Source
    section

  [ Christophe Prud'homme ]
  * METISLib/metis.h, ParMETISLib/parmetislib.h: make metis/parmetis
    headers usable

 -- Christophe Prud'homme <prudhomm@debian.org>  Mon, 09 Jul 2007 09:38:31 +0200

parmetis (3.1-4) unstable; urgency=low

  * Install headers from metis and parmetis in there respective
    subdirectories (/usr/include/metis and /usr/include/parmetis)
  * Use CDBS
  * Updated Standards-Version to 3.7.2 (no change)
  * Taking over parmetis maintenance-ship

 -- Christophe Prud'homme <prudhomm@debian.org>  Thu, 12 Oct 2006 13:49:49 +0200

parmetis (3.1-3) unstable; urgency=low

  * Rebuild using new mpich library package.
  * Fixed libparmetis-dev Depends in control.
  * Switched from mpicc to gcc to get shlib dependencies right.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue, 30 Aug 2005 13:18:35 -0400

parmetis (3.1-2) unstable; urgency=low

  * Declared conflict between parmetis-test and pimppa (closes: #308846).
  * Changed mpich build dependency to libmpich1.0-dev.
  * Other minor changes to dependencies.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Wed, 18 May 2005 06:40:33 -0400

parmetis (3.1-1) unstable; urgency=low

  * New upstream.
  * Removed redundant data from parmetis-test package which is already in -doc,
    adjusted the ptest and meshtest man pages accordingly (closes: #233428).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Wed, 18 Feb 2004 11:46:58 -0500

parmetis (3.0-3) unstable; urgency=low

  * Fixed parmetis.h to work with C++. (closes: #200904)
  * Added shared library with its very own package.
  * Changed name of -dev package.
  * Added -test package with binaries and example files from Test dir.
  * Added overrides files because lintian mistakenly thinks this is gpl. :-)

 -- Adam C. Powell, IV <hazelsct@debian.org>  Thu,  7 Aug 2003 20:01:45 -0400

parmetis (3.0-2) unstable; urgency=low

  * New permission from upstream should result in acceptance (closes: #186116).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue,  8 Apr 2003 17:54:53 -0400

parmetis (3.0-1) unstable; urgency=low

  * First packaging attempt, first upload (closes: #186116).
  * Only static libraries for now, since that's all that upstream generates.



=== debian/control ===
Source: parmetis
Section: non-free/math
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Adam C. Powell IV <hazelsct@debian.org>, Christophe Prud'homme <prudhomm@debian.org>
Standards-Version: 3.9.2
Homepage: http://glaros.dtc.umn.edu/gkhome/metis/parmetis/overview
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/parmetis/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/parmetis/trunk/
Build-Depends: cdbs, debhelper (>> 5), mpi-default-dev, mpi-default-bin
XS-Autobuild: yes

Package: libparmetis-dev
Architecture: any
Section: non-free/libdevel
Depends: libparmetis3.1 (= ${binary:Version}), ${misc:Depends}, mpi-default-dev
Suggests: parmetis-doc
Replaces: parmetis-dev
Conflicts: parmetis-dev
Description: Parallel Graph Partitioning and Sparse Matrix Ordering Libs: Devel
 ParMetis computes minimal-cut partitions of graphs and meshes in parallel, and
 orders variables for minimal fill when using direct solvers for sparse
 matrices.  It does all this in parallel, and also can efficiently re-partition
 a graph or mesh whose connectivity has changed.
 .
 This package contains files needed to develop programs using ParMetis.

Package: libparmetis3.1
Architecture: any
Section: non-free/libs
Depends: ${shlibs:Depends}, ${misc:Depends}, mpi-default-dev
Description: Parallel Graph Partitioning and Sparse Matrix Ordering Shared Libs
 ParMetis computes minimal-cut partitions of graphs and meshes in parallel, and
 orders variables for minimal fill when using direct solvers for sparse
 matrices.  It does all this in parallel, and also can efficiently re-partition
 a graph or mesh whose connectivity has changed.
 .
 This package contains the ParMetis shared libraries.

Package: parmetis-test
Architecture: any
Section: non-free/math
Depends: ${shlibs:Depends}, ${misc:Depends}, mpi-default-bin
Recommends: parmetis-doc
Conflicts: pimppa
Description: Parallel Graph Partitioning and Sparse Matrix Ordering Tests
 ParMetis computes minimal-cut partitions of graphs and meshes in parallel, and
 orders variables for minimal fill when using direct solvers for sparse
 matrices.  It does all this in parallel, and also can efficiently re-partition
 a graph or mesh whose connectivity has changed.
 .
 This package contains programs which test the ParMetis libraries using files
 in the parmetis-doc package's examples directory.

Package: parmetis-doc
Architecture: all
Depends: ${misc:Depends}
Section: non-free/doc
Description: Parallel Graph Partitioning and Sparse Matrix Ordering Lib - Docs
 ParMetis computes minimal-cut partitions of graphs and meshes in parallel, and
 orders variables for minimal fill when using direct solvers for sparse
 matrices.  It does all this in parallel, and also can efficiently re-partition
 a graph or mesh whose connectivity has changed.
 .
 This package contains the documentation and example files.

=== debian/rules ===
#!/usr/bin/make -f
# This file is public domain.

# where sources are
DEB_SRCDIR = $(CURDIR)/
# in which directory to build
DEB_BUILDDIR = $(DEB_SRCDIR)/
# in which directory to install the sofware
DEB_DESTDIR = $(CURDIR)/debian/tmp

#DEB_TAR_SRCDIR                  := parmetis-3.1
DEB_AUTO_CLEANUP_RCS            := yes

export MACHINE=LINUX


DEB_MAKE_CLEAN_TARGET    := clean
DEB_MAKE_INSTALL_TARGET  := #install DESTDIR=$(CURDIR)/debian/tmp/
# no check for this software
DEB_MAKE_CHECK_TARGET :=

DEB_DH_COMPRESS_ARGS := -X pdf


include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/debhelper.mk
#include /usr/share/cdbs/1/rules/tarball.mk
#include /usr/share/cdbs/1/rules/simple-patchsys.mk

INSTALL_PROG=install -D
INSTALL_DATA=install -m 644 -D


#DEB_MAKE_ENVVARS :=
CFLAGS=-O3 -Wall
CXXFLAGS=-O3 -Wall

XTRALIBS=-lmpi
LIBS=-lmpi
LIBDIR=

CPPFLAGS=-I. -I.. -I$(DEB_SRCDIR) -I/usr/include/mpi

makebuilddir::
	-ln -s METISLib metis
	-ln -s ParMETISLib parmetis

clean::
	-rm metis parmetis
	-rm ParMETISLib/ParMETISLib METISLib/METISLib

=== debian/watch ===
version=3
http://glaros.dtc.umn.edu/gkhome/metis/parmetis/download \
 /gkhome/fetch/sw/parmetis/ParMetis-([\d.]+)\.tar\.gz

## parmetis 4.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ParMETIS)

set(GKLIB_PATH METIS/GKlib CACHE PATH "path to GKlib")
set(METIS_PATH METIS CACHE PATH "path to METIS")

# Symlink ./metis to wherever metis is. This allows files to be
# included from metis/libmetis/.
execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${METIS_PATH} metis)

# Search for MPI.
# GK commented this out as it seems to be creating problems
# include(FindMPI)
# if(NOT MPI_FOUND)
#   message(FATAL_ERROR "mpi is not found")
# endif()
# set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${MPI_COMPILE_FLAGS}")

# Prepare libraries.
if(SHARED)
  set(ParMETIS_LIBRARY_TYPE SHARED)
else()
  set(ParMETIS_LIBRARY_TYPE STATIC)
endif()

include(${GKLIB_PATH}/GKlibSystem.cmake)

# List of paths that the compiler will search for header files.
# i.e., the -I equivalent
include_directories(include)
include_directories(${MPI_INCLUDE_PATH})
include_directories(${GKLIB_PATH})
include_directories(${METIS_PATH}/include)

# List of directories that cmake will look for CMakeLists.txt
add_subdirectory(${METIS_PATH}/libmetis ${CMAKE_BINARY_DIR}/libmetis)
add_subdirectory(include)
add_subdirectory(libparmetis)
add_subdirectory(programs)

# This is for testing during development and is not being distributed
#add_subdirectory(test)

=== Makefile ===
# Configuration options.
gdb        = not-set
assert     = not-set
assert2    = not-set
debug      = not-set
openmp     = not-set
prefix     = not-set
gklib_path = not-set
metis_path = not-set
shared     = not-set
cc         = mpicc
cxx        = mpicxx


# Basically proxies everything to the builddir cmake.

PKGNAME = parmetis-4.0.3

cputype = $(shell uname -m | sed "s/\\ /_/g")
systype = $(shell uname -s)

BUILDDIR = build/$(systype)-$(cputype)

# Process configuration options.
CONFIG_FLAGS = -DCMAKE_VERBOSE_MAKEFILE=1
ifeq ($(gklib_path), not-set)
    gklib_path = metis/GKlib
endif
ifeq ($(metis_path), not-set)
    metis_path = metis
endif
CONFIG_FLAGS += -DGKLIB_PATH=$(abspath $(gklib_path)) -DMETIS_PATH=$(abspath $(metis_path))
ifneq ($(gdb), not-set)
    CONFIG_FLAGS += -DGDB=$(gdb)
endif
ifneq ($(assert), not-set)
    CONFIG_FLAGS += -DASSERT=$(assert)
endif
ifneq ($(assert2), not-set)
    CONFIG_FLAGS += -DASSERT2=$(assert2)
endif
ifneq ($(debug), not-set)
    CONFIG_FLAGS += -DDEBUG=$(debug)
endif
ifneq ($(openmp), not-set)
    CONFIG_FLAGS += -DOPENMP=$(openmp)
endif
ifneq ($(prefix), not-set)
    CONFIG_FLAGS += -DCMAKE_INSTALL_PREFIX=$(prefix)
endif
ifneq ($(shared), not-set)
    CONFIG_FLAGS += -DSHARED=1
endif
ifneq ($(cc), not-set)
    CONFIG_FLAGS += -DCMAKE_C_COMPILER=$(cc)
endif
ifneq ($(cxx), not-set)
    CONFIG_FLAGS += -DCMAKE_CXX_COMPILER=$(cxx)
endif

define run-config
mkdir -p $(BUILDDIR)
cd $(BUILDDIR) && cmake $(CURDIR) $(CONFIG_FLAGS)
endef

all clean install:
	@if [ ! -f $(BUILDDIR)/Makefile ]; then \
		more BUILD.txt; \
	else \
	  	make -C $(BUILDDIR) $@ $(MAKEFLAGS); \
	fi

uninstall:
	xargs rm < $(BUILDDIR)/install_manifest.txt

config: distclean
	$(run-config)

distclean:
	rm -rf $(BUILDDIR)

remake:
	find . -name CMakeLists.txt -exec touch {} ';'

dist:
	util/mkdist.sh $(PKGNAME)


.PHONY: config distclean dist all clean install uninstall remake

=== libparmetis/CMakeLists.txt ===
# Include directories for library code.
include_directories(.)
# Find sources.
file(GLOB parmetis_sources *.c)
# Create libparmetis
add_library(parmetis ${ParMETIS_LIBRARY_TYPE} ${parmetis_sources})
# Link with metis and MPI libraries.
target_link_libraries(parmetis metis ${MPI_LIBRARIES})
set_target_properties(parmetis PROPERTIES LINK_FLAGS "${MPI_LINK_FLAGS}")

install(TARGETS parmetis
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib
  ARCHIVE DESTINATION lib)

=== programs/CMakeLists.txt ===
include_directories(.)
# Create programs.
add_executable(ptest ptest.c io.c adaptgraph.c)
add_executable(mtest mtest.c io.c)
add_executable(parmetis_prog parmetis.c io.c adaptgraph.c)
set_target_properties(parmetis_prog PROPERTIES OUTPUT_NAME parmetis)
add_executable(pometis pometis.c io.c)
# Link to libparmetis.
foreach(prog ptest mtest parmetis_prog pometis)
  target_link_libraries(${prog} parmetis)
endforeach(prog)

install(TARGETS ptest mtest parmetis_prog pometis
  RUNTIME DESTINATION bin)

=== debian/changelog ===
parmetis (4.0.3-7.1~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Lucas Kanashiro <kanashiro@debian.org>  Mon, 05 Feb 2024 14:57:11 -0300

parmetis (4.0.3-7) unstable; urgency=medium

  * Team upload.
  * d/tests/build1: allow oversubscription with OpenMPI.

 -- Ansgar <ansgar@debian.org>  Sun, 17 Jul 2022 22:21:07 +0200

parmetis (4.0.3-6) unstable; urgency=medium

  * Team upload.
  * d/tests/control:
    - add dependency on g++, required to built the test program
    - remove dependency on libmetis-dev as libparmetis-dev depends on it
  * d/control: add Rules-Requires-Root: no
  * d/control: use debhelper compat level 13
    - d/not-installed: list usr/bin/{par,po}metis
  * d/rules: use `DEB_*_MAINT_APPEND` to pass compiler flags.
    With this change Debian's default flags are used as well.
  * d/control: update Vcs-* fields to point to salsa.d.o
  * d/control: use Standards-Version: 4.6.1

 -- Ansgar <ansgar@debian.org>  Sat, 16 Jul 2022 20:29:53 +0200

parmetis (4.0.3-5) unstable; urgency=medium

  * Team upload.

  [ Wolfgang Fütterer ]
  * [9bc9267] Removed Christophe from uploaders list (Closes: #835020)

  [ Ansgar Burchardt ]
  * libparmetis4.0: remove `postinst` maintainer script: it only contained
    the "#DEBHELPER#" marker. Closes: #843279
  * libparmetis-dev: add dependency on libmetis-dev. Closes: #862659

 -- Ansgar Burchardt <ansgar@debian.org>  Mon, 15 May 2017 20:21:44 +0200

parmetis (4.0.3-4) unstable; urgency=medium

  * Added autopkgtest
  * Release package to unstable

 -- Wolfgang Fuetterer <debian@wlf-online.de>  Tue, 28 Jul 2015 10:47:27 +0200

parmetis (4.0.3-3) experimental; urgency=medium

  [ Wolfgang Fuetterer ]

  * Package migrated to use git
  * Set Standards-Versions: 3.9.6. No changes.
  * Dropped duplicated section field in control file for parmetis-test
  * Added symbols file for shared library
  * Changed VCS-field to use git now
  * Added myself to the uploaders field (Closes: #706710)

  [ Andrew Miller <andrew@amxl.com> ]

  * Team upload
  * Standards-Version updated to version 3.9.3.1
  * Fix watch file with respect to case changes on the project.
  * Update to parmetis-4.0.2

  [ Christophe Trophime <christophe.trophime@lncmi.cnrs.fr> ]

  * Build using libmetis-dev

 -- Wolfgang Fuetterer <debian@wlf-online.de>  Sun, 26 Oct 2014 11:27:07 +0100

=== debian/control ===
Source: parmetis
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Adam C. Powell IV <hazelsct@debian.org>,
           Wolfgang Fuetterer <debian@wlf-online.de>
Section: non-free/math
XS-Autobuild: yes
Priority: optional
Build-Depends: debhelper-compat (= 13),
               mpi-default-dev,
               mpi-default-bin,
               cmake,
               libmetis-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/science-team/parmetis
Vcs-Git: https://salsa.debian.org/science-team/parmetis.git
Homepage: http://glaros.dtc.umn.edu/gkhome/metis/parmetis/overview
Rules-Requires-Root: no

Package: libparmetis-dev
Architecture: any
Section: non-free/libdevel
Depends: libparmetis4.0t64 (= ${binary:Version}),
         ${misc:Depends},
         mpi-default-dev,
         libmetis-dev
Suggests: parmetis-doc
Conflicts: parmetis-dev
Replaces: parmetis-dev
Description: Parallel Graph Partitioning and Sparse Matrix Ordering Libs: Devel
 ParMetis computes minimal-cut partitions of graphs and meshes in parallel, and
 orders variables for minimal fill when using direct solvers for sparse
 matrices.  It does all this in parallel, and also can efficiently re-partition
 a graph or mesh whose connectivity has changed.
 .
 This package contains files needed to develop programs using ParMetis.

Package: libparmetis4.0t64
Provides: ${t64:Provides}
Replaces: libparmetis4.0
Breaks: libparmetis4.0 (<< ${source:Version})
Architecture: any
Section: non-free/libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mpi-default-dev
Description: Parallel Graph Partitioning and Sparse Matrix Ordering Shared Libs
 ParMetis computes minimal-cut partitions of graphs and meshes in parallel, and
 orders variables for minimal fill when using direct solvers for sparse
 matrices.  It does all this in parallel, and also can efficiently re-partition
 a graph or mesh whose connectivity has changed.
 .
 This package contains the ParMetis shared libraries.

Package: parmetis-test
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libparmetis4.0t64,
         mpi-default-bin
Recommends: parmetis-doc
Conflicts: pimppa
Description: Parallel Graph Partitioning and Sparse Matrix Ordering Tests
 ParMetis computes minimal-cut partitions of graphs and meshes in parallel, and
 orders variables for minimal fill when using direct solvers for sparse
 matrices.  It does all this in parallel, and also can efficiently re-partition
 a graph or mesh whose connectivity has changed.
 .
 This package contains programs which test the ParMetis libraries using files
 in the parmetis-doc package's examples directory.

Package: parmetis-doc
Architecture: all
Section: non-free/doc
Depends: ${misc:Depends}
Description: Parallel Graph Partitioning and Sparse Matrix Ordering Lib - Docs
 ParMetis computes minimal-cut partitions of graphs and meshes in parallel, and
 orders variables for minimal fill when using direct solvers for sparse
 matrices.  It does all this in parallel, and also can efficiently re-partition
 a graph or mesh whose connectivity has changed.
 .
 This package contains the documentation and example files.

=== debian/tests/control ===
Tests: build1
Depends: g++, libparmetis-dev, mpi-default-bin

=== debian/watch ===
version=3
http://glaros.dtc.umn.edu/gkhome/metis/parmetis/download \
 /gkhome/fetch/sw/parmetis/parmetis-([\d.]+)\.tar\.gz
